/******************************************************************************
 *
 *	Pocket Balloon
 *	color edition
 *	ver 1.1.0
 *	2008. 4
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include <SonyCLIE.h>
#include "defrsc.h"

#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/
Boolean check_hard_key( EventPtr );
void get_pen_input( void );
void check_enter( EventPtr );
Int32 set_event_interval( void );
void init_main_form( FormPtr );
void make_bitmap_offscreen( void );
Err rom_check( UInt32, UInt16 );
void *get_object_ptr( UInt16 );
Boolean main_form_command( UInt16 );
Boolean main_form_handler( EventPtr );
Boolean app_handle_event( EventPtr );
void event_loop( void );
Err app_start( void );
void app_stop( void );
UInt32 my_app_main( UInt16, MemPtr, UInt16 );



/************************************************
 *	n[hL[
 ***********************************************/
void
get_hard_key( void )
{
  // key = A, keyf = ͂߂̈̂
  g_gs.keyf = g_gs.key;
  g_gs.keyf ^= 0xffffffff;

  g_gs.key = KeyCurrentState();
  g_gs.keyf &= g_gs.key;
}



/********************************************************************
 *	X^[eBbNȊ֐Q
 *******************************************************************/

/************************************************
 *	\[Xrbg}bvItXN[쐬
 ***********************************************/
static void
make_bitmap_offscreen( void )
{
  int i;
  WinHandle save;
  UInt16 error;
  MemHandle bitmap_h;
  BitmapPtr bitmap_p;


  save = WinGetDrawWindow();

  // LN^@ItXN[쐬
  for( i = 0; i < MAX_BMP; i++ )
    {
      bitmap_h = DmGetResource( bitmapRsc, 1000 + i );
      bitmap_p = MemHandleLock( bitmap_h );

      g_chr_handle[i] = WinCreateOffscreenWindow( bitmap_p ->width, bitmap_p ->height,
                                             screenFormat, &error );
      ErrFatalDisplayIf( error, "Error loading images" );

      WinSetDrawWindow( g_chr_handle[i] );
      WinDrawBitmap( bitmap_p, 0, 0 );

      MemPtrUnlock( bitmap_p );
      DmReleaseResource( bitmap_h );
    }

  WinSetDrawWindow( save );
}



/************************************************
 *	n[hL[̃`FbN
 ***********************************************/
static Boolean
check_hard_key( EventPtr event_p )
{
  Boolean handled = false;


  switch( event_p ->eType )
    {
    case keyDownEvent:
      if( TxtGlueCharIsVirtual( event_p ->data.keyDown.modifiers,
                                event_p ->data.keyDown.chr) )
        {
          switch( event_p ->data.keyDown.chr )
            {
            case vchrHard1:
            case vchrHard2:
            case vchrHard3:
            case vchrHard4:
              g_gs.start &= (~FLG_GAME_PAUSE);	// |[Y
              handled = true;
              break;

            case vchrPageDown:
            case vchrPageUp:
              // Q[AJnO
              if( !(g_gs.start & (FLG_GAME_OVER | FLG_GAME_TITLE)) )
                {
                  g_gs.start |= FLG_GAME_PAUSE;	// |[Y
                  //              set_se( click );
                }
              handled = true;
              break;
            }
        }
    }

  return handled;
}



/************************************************
 *	ANeBu`FbN
 ***********************************************/
static void
check_enter( EventPtr event_p )
{
  switch( event_p ->eType )
    {
    case winEnterEvent:
      if( event_p ->data.winEnter.enterWindow == (WinHandle) FrmGetFormPtr( MainForm )
          && event_p ->data.winEnter.enterWindow == (WinHandle) FrmGetFirstForm() )
        g_gs.start |= FLG_GAME_START;
      break;

    case winExitEvent:
      if( event_p ->data.winExit.exitWindow == (WinHandle) FrmGetFormPtr( MainForm ) )
        g_gs.start &= FLG_GAME_STOP;
      break;
    }
}



/************************************************
 *	ROM̃o[W`FbN
 *	PalmOS 3.0ȍ~H
 ***********************************************/
static Err
rom_check(UInt32 requiredVersion, UInt16 launchFlags)
{
  UInt32 rom_ver;

  // See if we're on in minimum required version of the ROM or later.
  FtrGet(sysFtrCreator, sysFtrNumROMVersion, &rom_ver);

  if( rom_ver < requiredVersion )
    {
      if( ( launchFlags & ( sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp ) )
          == ( sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp ) )
        {
          FrmAlert( RomIncompatibleAlert );

          // Palm OS 1.0 will continuously relaunch this app unless we switch to 
          // another safe one.
          if( rom_ver < ourMinVersion )
            {
              AppLaunchWithCommand( sysFileCDefaultApp, sysAppLaunchCmdNormalLaunch, NULL );
            }
        }

      return sysErrRomIncompatible;
    }

  return errNone;
}


/************************************************
 *	Cxg[ṽEFCgݒ
 ***********************************************/
static Int32
set_event_interval( void )
{
  Int32 wait;


  // Q[JnO^f
  if( !(g_gs.start & FLG_GAME_START) ) return wait = evtWaitForever;

  wait = g_event_interval + DEF_EVENT_TICK - TimGetTicks();
  if( wait < 0 ) wait = 0;

  return wait;
}



/************************************************
 *	tH[̃IuWFNg̃|C^擾
 ***********************************************/
static void *
get_object_ptr( UInt16 object_ID )
{
  FormPtr frm_p;


  frm_p = FrmGetActiveForm();
  return FrmGetObjectPtr( frm_p, FrmGetObjectIndex( frm_p, object_ID ) );
}



/************************************************
 *	CtH[j[R}h
 ***********************************************/
static Boolean
main_form_command( UInt16 command )
{
  Boolean handled = false;
  FormPtr frm_p;


  switch( command )
    {
    case MainOptionsNewGame:
      MenuEraseStatus( 0 );

      // j[Q[
      init_game_status();
      clear_screen();

      g_gs.start = FLG_GAME_START | FLG_GAME_TITLE;
      g_event_interval = TimGetTicks();
      handled = true;
      break;

    case MainOptionsScore:
      // XRALO
      show_ranking();

      g_event_interval = TimGetTicks();
      handled = true;
      break;

    case MainOptionsAboutBALLOON:
      // AoEgʂ̕\
      MenuEraseStatus( 0 );
      frm_p = FrmInitForm( AboutForm );
      FrmDoDialog( frm_p );
      FrmDeleteForm( frm_p );

      g_event_interval = TimGetTicks();
      handled = true;
      break;

    case MainOptionsHelp:
      // wv
      FrmHelp( key_helpString );
      g_event_interval = TimGetTicks();
      handled = true;
      break;
    }

  return handled;
}



/************************************************
 *	CtH[Cxgnh
 ***********************************************/
static Boolean
main_form_handler( EventPtr event_p )
{
  Boolean handled = false;
  FormPtr frm_p;


  switch( event_p ->eType )
    {
    case nilEvent:
      // Q[{
//      play_game();
      handled = true;
      break;

    case menuEvent:
      return main_form_command( event_p ->data.menu.itemID );

    case frmOpenEvent:
      frm_p = FrmGetActiveForm();
      FrmDrawForm( frm_p );
      handled = true;
      break;

    case penUpEvent:
      g_gs.pen_down = false;
      g_gs.pen_move = false;
      handled = true;
      break;

    case penMoveEvent:
      g_gs.pen_move = true;

    case penDownEvent:
      g_gs.pen_down = true;
      // ʒu␳
      g_gs.pen_x = event_p ->screenX + BACK_W_BLANK;
      g_gs.pen_y = event_p ->screenY + BACK_H_BLANK;

      if( g_gs.pen_y > 16+BACK_H_BLANK )
        g_gs.start &= ( ~FLG_GAME_PAUSE );	// |[Y
      handled = true;
      break;
    }

  return handled;
}



/************************************************
 *	tH[̃[h
 ***********************************************/
static Boolean
app_handle_event( EventPtr event_p )
{
  UInt16 form_id;
  FormPtr frm_p;


  if( event_p ->eType == frmLoadEvent )
    {
      form_id = event_p ->data.frmLoad.formID;
      frm_p = FrmInitForm( form_id );
      FrmSetActiveForm( frm_p );

      switch( form_id )
        {
        case MainForm:
          FrmSetEventHandler( frm_p, main_form_handler );
          break;
        }

      return true;
    }

  return false;
}



/************************************************
 *	Cxg[v
 ***********************************************/
static void
event_loop( void )
{
  UInt16 error;
  EventType event;


  do
    {
      // Cxg擾
      EvtGetEvent( &event, set_event_interval() );

      // ANeBu
      check_enter( &event );
      // Q[̃C
      play_game();

      // n[hL[ŃXLbv
      if( !check_hard_key( &event ) )
        if( SysHandleEvent( &event ) ) continue;

      if( !MenuHandleEvent( 0, &event, &error ) )
        if( !app_handle_event( &event ) )
          FrmDispatchEvent( &event );
    }
  while( event.eType != appStopEvent );
}



/************************************************
 *	AvJn
 ***********************************************/
static Err
app_start( void )
{
  Int16 ver;
  UInt16 size;
  Err error;
  GamePrefType pref;


  // XN[
  if( init_screen() )
    {
      FrmAlert( NonSupportedScreenAlert );
      return -1;
    }

  //rbg}bv쐬
  make_bitmap_offscreen();

  // _}CY
  SysRandom ( TimGetTicks() );

  // ʉON
  g_gs.sound = true;

  // XRALO
  init_hiscore();

  // vt@X擾
  size = sizeof( GamePrefType );
  ver = PrefGetAppPreferences( appFileCreator, appPrefID, &pref, &size, true );
  if( ver == noPreferenceFound
      || ver != appPrefVersionNum
      || size != sizeof( GamePrefType) )
    {
      // 
      init_hiscore();
    }
  else
    {
      // vt@X̃Rs[
      error = MemMove( &g_gs.last_name, &pref, sizeof( GamePrefType ) );
      // G[
      ErrFatalDisplayIf( error, "Error loading Preferences" );
    }

  //// m
  // Gobt@
  g_gs.stage.thorn_p = (ThornType *)MemPtrNew( sizeof( ThornType )*MAX_THORN );
  ErrFatalDisplayIf( !g_gs.stage.thorn_p, "Error allocating Buffers" );
  // ACeobt@
  g_gs.stage.balloon_p = (BalloonType *)MemPtrNew( sizeof( BalloonType )*MAX_BALLOON );
  ErrFatalDisplayIf( !g_gs.stage.balloon_p, "Error allocating Buffers" );
  // obt@
  g_gs.stage.thander_p = (ThanderType *)MemPtrNew( sizeof( ThanderType )*MAX_THANDER );
  ErrFatalDisplayIf( !g_gs.stage.thander_p, "Error allocating Buffers" );
  // obt@
  g_gs.stage.star_p = (StarType *)MemPtrNew( sizeof( StarType )*MAX_STAR );
  ErrFatalDisplayIf( !g_gs.stage.star_p, "Error allocating Buffers" );

  // Q[̏
  init_game_status();

  // {[擾
  g_volume = PrefGetPreference( prefGameSoundVolume );
  // bZ[WpEFCg
  g_mes_wait = 0;

  // ݂TICKl擾
  g_event_interval = TimGetTicks();

  return errNone;
}



/************************************************
 *	AvI
 ***********************************************/
static void
app_stop( void )
{
  int i;
  UInt16 hr_ref_num;
  GamePrefType pref;

  // 
  MemPtrFree( g_gs.stage.thorn_p );
  MemPtrFree( g_gs.stage.balloon_p );
  MemPtrFree( g_gs.stage.thander_p );
  MemPtrFree( g_gs.stage.star_p );

  // SẴItXN[
  for( i = 0; i < MAX_BMP; i++ )
    WinDeleteWindow( g_chr_handle[i], false );

  // obNXN[
  WinDeleteWindow( g_back_screen_h, false );

  // ʂ߂
  if( ! SysLibFind( sonySysLibNameHR, &hr_ref_num ) )
    {
      HROpen( hr_ref_num );
      HRWinScreenMode( hr_ref_num,
                       winScreenModeSet,
                       &g_save_screen.width,
                       &g_save_screen.height,
                       &g_save_screen.depth,
                       NULL );
      HRClose( hr_ref_num );
    }
  else
    {
      WinScreenMode( winScreenModeSet,
                     &g_save_screen.width,
                     &g_save_screen.height,
                     &g_save_screen.depth,
                     NULL );
    }

  // vt@X̃Rs[
  MemMove( &pref, &g_gs.last_name, sizeof( GamePrefType ) );
  // Q[̏ԕۑ
  PrefSetAppPreferences( appFileCreator, appPrefID, appPrefVersionNum,
                         &pref, sizeof( GamePrefType ), true );

  FrmCloseAllForms();
}



/************************************************
 *	C
 ***********************************************/
static UInt32
my_app_main( UInt16 cmd, MemPtr /*cmdPBP*/, UInt16 launchFlags )
{
  Err error;

  // ROM`FbN OS3.5ȍ~
  error = rom_check( PalmRomVer350, launchFlags );
  if( error ) return error;

  switch( cmd )
    {
    case sysAppLaunchCmdNormalLaunch:
      error = app_start();
      if( error ) return error;

      FrmGotoForm( MainForm );
      event_loop();
      app_stop();
      break;

    default:
      break;
    }

  return errNone;
}



/************************************************
 *	Gg[
 ***********************************************/
UInt32
PilotMain( UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags )
{
  return my_app_main( cmd, cmdPBP, launchFlags );
}



